/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.wrapper;

import org.springblade.community.entity.Agency;
import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IAgencyClient;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.estate.entity.Repair;
import org.springblade.estate.vo.RepairVO;
import org.springblade.system.expand.feign.IConfClient;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 报事工单包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-03-30
 */
public class RepairWrapper extends BaseEntityWrapper<Repair, RepairVO> {

	private static IConfClient confClient;
	private static IAgencyClient agencyClient;
	private static IResidentialClient residentialClient;

	public static RepairWrapper build() {
		return new RepairWrapper();
 	}

 	static {
		confClient = SpringUtil.getBean(IConfClient.class);
		agencyClient = SpringUtil.getBean(IAgencyClient.class);
		residentialClient = SpringUtil.getBean(IResidentialClient.class);
	}

	@Override
	public RepairVO entityVO(Repair repair) {
		RepairVO repairVO = Objects.requireNonNull(BeanUtil.copy(repair, RepairVO.class));
		if(StringUtil.isNotBlank(repair.getPic())){
			List<String> picPathList = Func.toStrList(repair.getPic());
			List<String> picList = new ArrayList<>();
			for(String pic : picPathList){
				picList.add(confClient.addPrefix(pic));
			}
			repairVO.setPic(Func.join(picList, ","));
		}
		Agency agency = agencyClient.getById(repair.getAgencyId());
		if(agency != null){
			repairVO.setAgencyName(agency.getName());
		}
		Residential residential = residentialClient.getById(repair.getResidentialId());
		if(residential != null){
			repairVO.setResidentialName(residential.getName());
		}
		return repairVO;
	}

}
